import logging
import os.path

# the directory that lists every valid app
_APPS_DIR = "usr/share/applications"


class DesktopFinder:
    """
    Searches for desktop entries. Queries require a ContentIndex where
    all 'DesktopFinder.prefixes' paths are indexed.
    """

    def search(self, cache):
        """
        Searches the archive for all application desktop entries.

        @index: A ContentsIndex with this finder's prefixes indexed
        @returns list of ('packagename', 'path/to/entry') pairs
        """
        pattern = ".*\.desktop$"
        return cache.search(pattern, _APPS_DIR)

    prefixes = (_APPS_DIR,)
